<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AtualizaDocumentoCompraResponse StructType
 * @subpackage Structs
 */
class AtualizaDocumentoCompraResponse extends AbstractStructBase
{
    /**
     * The AtualizaDocumentoCompraResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $AtualizaDocumentoCompraResult;
    /**
     * The entidadefinal
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecComprasERP
     */
    public $entidadefinal;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for AtualizaDocumentoCompraResponse
     * @uses AtualizaDocumentoCompraResponse::setAtualizaDocumentoCompraResult()
     * @uses AtualizaDocumentoCompraResponse::setEntidadefinal()
     * @uses AtualizaDocumentoCompraResponse::setMensagem()
     * @uses AtualizaDocumentoCompraResponse::setSucesso()
     * @param bool $atualizaDocumentoCompraResult
     * @param \StructType\CabecComprasERP $entidadefinal
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($atualizaDocumentoCompraResult = null, \StructType\CabecComprasERP $entidadefinal = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setAtualizaDocumentoCompraResult($atualizaDocumentoCompraResult)
            ->setEntidadefinal($entidadefinal)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get AtualizaDocumentoCompraResult value
     * @return bool|null
     */
    public function getAtualizaDocumentoCompraResult()
    {
        return $this->AtualizaDocumentoCompraResult;
    }
    /**
     * Set AtualizaDocumentoCompraResult value
     * @param bool $atualizaDocumentoCompraResult
     * @return \StructType\AtualizaDocumentoCompraResponse
     */
    public function setAtualizaDocumentoCompraResult($atualizaDocumentoCompraResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($atualizaDocumentoCompraResult) && !is_bool($atualizaDocumentoCompraResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($atualizaDocumentoCompraResult)), __LINE__);
        }
        $this->AtualizaDocumentoCompraResult = $atualizaDocumentoCompraResult;
        return $this;
    }
    /**
     * Get entidadefinal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecComprasERP|null
     */
    public function getEntidadefinal()
    {
        return isset($this->entidadefinal) ? $this->entidadefinal : null;
    }
    /**
     * Set entidadefinal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CabecComprasERP $entidadefinal
     * @return \StructType\AtualizaDocumentoCompraResponse
     */
    public function setEntidadefinal(\StructType\CabecComprasERP $entidadefinal = null)
    {
        if (is_null($entidadefinal) || (is_array($entidadefinal) && empty($entidadefinal))) {
            unset($this->entidadefinal);
        } else {
            $this->entidadefinal = $entidadefinal;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\AtualizaDocumentoCompraResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\AtualizaDocumentoCompraResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AtualizaDocumentoCompraResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
